#include "crasm86.inc"
#include "asm86.h"

.org _asm_exec_ram

	nop
	jp ProgStart
	.dw 0
	.dw ShellTitle

ShellTitle:
	.db "DigiSet 1.0",0

ProgStart:
	call _flushallmenus
	call _runindicoff
top:
	call _clrLCD
	ld hl, $0000
	ld (_pencol), hl
	ld hl, titletext
	call _vputs					;'DigiSet 1.0'
	ld hl, $004B
	ld (_pencol), hl
	ld hl, credittext
	call _vputs					;'by Cassady Roop'
	call underline
	call makemenu				;create a menu bar
toploop:
	call _getkey
	cp kf5
	jp z, _clrLCD				;clear and quit
	cp kf2
	jr z, uninstall
	cp kf1
	jr z, install
	jr nz, toploop


uninstall:
	ld hl, $5A92
	rst 20h
	rst 10h						;findsym
	jr c, success				;no carry means file is already nonexistant
	call _delvar				;delete it
	res sqrtkeyinstalled, (IY+sqrtflags)
	jr success

install:
	ld hl, $5A92
	rst 20h
	rst 10h
	jr c, install_continue
	call _delvar
install_continue:
 	ld hl,$5a92								;$5a92 = $c9,4,"[sqrt]KEY"
	rst 20h                					;[sqrt]KEY -> OP1
	ld hl, sqrtkeycode_end - sqrtkeycode_begin
	push hl									;data length
	call _CREATEPROG          					;creates program
	ld a,b										;for abs address
	ex de,hl									;for abs address bde
	call $4c3f
	call _SET_ABS_DEST_ADDR					;for _mm_ldir
	xor a										;less than 16k, so zero a in ahl
 	pop hl										;code length
 	call _SET_MM_NUM_BYTES						;copy length
 	xor a										;page 0
 	ld hl,sqrtkeycode
 	call _SET_ABS_SRC_ADDR						;for _mm_ldir
 	call _mm_ldir								;block copy absolute addressing
	set sqrtKEYINSTALLED, (IY+SQRTFLAGS)       ;enables [sqrt]KEY program
	jp success

success:
	call _clrLCD
	ld hl, $1A27
	ld (_pencol), hl
	ld hl, successfultext
	call _vputs							;'Successful'
	call _getkey
	jp top

underline:
	ld hl, $FC70
	ld b, 32
underlineloop:
	ld (hl), $FF
	inc hl
	djnz underlineloop	
	ret

makemenu:									;draw menu
	ld hl, $FF80			;start byte of row 56 in video mem
	ld b, 32					;initialize counter
HLineLoop:
	ld (hl), $FF				;darken 8 pixels
	inc hl					;next byte
	djnz HLineLoop			;recycle
	ld hl, $FFA0			;vidmem, first byte of row 58
	ld b, 6					;initialize line counter
	ld de, $0003
VLineLoop:
	ld (hl), %11000000				;move to vidmem
	add hl, de				;HL+3=HL
	ld (hl), %11100000		
	add hl, de
	ld (hl), %0110000
	add hl, de
	ld (hl), %00011000
	add hl, de
	ld (hl), %00001100
	add hl, de
	ld (hl), %00000110
	inc hl					;next line
	djnz VLineLoop			;if not done, recycle
	ld hl, $FF8F
	ld a, %11111110				;remove unsightly piece of overshot
	ld (hl), a
	ld hl, $FF9F
	ld (hl), a
	ld hl, $3A03
	ld (_pencol), hl
	ld hl, installtext
	call _vputs					;
	ld hl, $3A1C
	ld (_pencol), hl
	ld hl, uninstalltext
	call _vputs					;
	ld hl, $3A6A
	ld (_pencol), hl
	ld hl, quittext
	call _vputs					;'Quit'
	ret

successfultext:
	.db "Successful",0
titletext:
	.db "DigiSet 1.0",0
credittext:
	.db "by Cassady Roop",0
installtext:
	.db "Install",0
uninstalltext:
	.db "UInst",0
quittext:
	.db "Quit",0


sqrtkeycode:
.org _asm_exec_ram-2
sqrtkeycode_begin:			;used to calculate data length
	.db $8e,$28				;asm prog token
	push bc
	push de
	call _POPOP1
	pop de
	pop bc
	ld a, (_ASM_REG_A)
	push af
	ld a, (_CXCURAPP)
	cp $01					;is it the homescreen?
	jp nz, sqrt_pop_quit	;if not, quit
	
	bit shift2nd, (IY+shiftflags)	;is 2nd activated?  We want them to be able to get to MODE...
	jp nz, sqrt_pop_quit
	pop af
	cp $00
	ret z					;if it is zero, then no key was pressed, so leave
	cp k_MORE				;MORE key pressed?
	jp nz, sqrt_quit		;if not, quit
	res sqrtkeyinstalled, (IY+sqrtflags)		;disable, so I can use _getkey in this routine
	call _cursoroff
	ld hl, $FC00
	ld de, _plotSScreen
	ld bc, 1024
	ldir					;save the screen
	ld hl, $FC00
	ld b, 128
sqrt_blackloop:
	ld (hl), $FF			;8 darkened pixels
	inc hl
	djnz sqrt_blackloop		;loop until 8 rows are done
	ld hl, $0001
	ld (_pencol), hl
	ld hl, sqrt_titletext
	set textinverse, (IY+textflags)
	call _vputs
	ld hl, $004B
	ld (_pencol), hl
	ld hl, sqrt_credittext
	call _vputs
	res textinverse, (IY+textflags)
drawBox:									;draw box around precision indicator
	ld hl, $FC80							;start of row 9
	ld (hl), %11111111
	inc hl
	ld (hl), %11100000
	ld hl, $FC80							;row 9
	ld b, 7									;b rows of the following:
	ld de, $0010							;one row's worth of bytes
drawboxleft:								;draw the right side of the box
	add hl, de								;next row
	ld (hl), %10000000						;draw bit 7, bit 2 dark, others light
	push hl
	inc hl
	ld (hl), %00100000
	pop hl
	djnz drawboxleft						
drawboxbottom:								;draw bottom side
	ld hl, $FD00
	ld (hl), %11111111
	inc hl
	ld (hl), %11100000
	
	ld hl, $3A03
	ld (_pencol), hl
	ld hl, floattext
	call _vputs
	ld hl, $3A23
	ld (_pencol), hl
	ld a, $0A
	call AtoDEC
	ld hl, $3A3D
	ld (_pencol), hl
	ld a, $0B
	call AtoDEC
	ld hl, $3A59
	ld (_pencol), hl
	ld a, $0C
	call AtoDEC
	ld hl, $3A74
	ld (_pencol), hl
	ld a, $0D
	call AtoDEC	

	ld hl, $0902
	ld (_pencol), hl
	ld a, (_fmtDigits)						;current precision value
	cp $FF									;ff= float
	jr z, sqrt_isFloat
	call AtoDEC								;display the number of digits, inside the box
	jr sqrt_keyloop
sqrt_isFloat:								;if it is FF, don't disp 255, disp 'F'
	ld a, 70								;'F' for Float
	call _vputmap							;disp it

sqrt_keyloop:
	call _getkey							;safe because I disabled sqrts when I entered this program
	cp kF1
	jr z, set_float
	cp kF2
	jr z, set_ten
	cp kF3
	jr z, set_eleven
	cp kF4
	jr z, set_twelve
	cp kF5
	jr z, set_thirteen
	cp $1C						;is it below numeric range?
	jp m, sqrt_keyloop			;not a valid keypress
	cp $26						;is it above numeric range?
	jp p, sqrt_keyloop			;not a valid keypress
	sub k0						;subtract _getkey value of zero key to get real value of number it represents
	jr sqrt_finish
set_float:
	ld a, $FF
	jr sqrt_finish
set_ten:
	ld a, $0A
	jr sqrt_finish
set_eleven:
	ld a, $0B
	jr sqrt_finish
set_twelve:
	ld a, $0C
	jr sqrt_finish
set_thirteen:
	ld a, $0D

sqrt_finish:
	ld (_fmtDigits), a			;write new value to memory
	set sqrtkeyinstalled, (IY+sqrtflags)		;re-enable this routine
	call _cursoron
	ld hl, _plotSScreen
	ld de, $FC00
	ld bc, 1024
	ldir					;copy the screen back
	ld a, $00				;last key that was pressed
	ret					;or _jforcecmdnochar, but it never makes it this far anyway...
sqrt_pop_quit:
	pop af
	cp a
	ret
sqrt_quit:
	cp a
	ret


floattext:
	.db "Float",0
sqrt_titletext:
	.db "DigiSet 1.0",0
sqrt_credittext:
	.db "by Cassady Roop",0




;-----------------------------------
;AtoDEC by Cassady Roop-- displays A as a decimal with NO leading zeroes.
;-----------------------------------
AtoDEC:
        ld h, 0
		ld l, a
        ld b, 3
        ld de, num_spot+2
atodecmain:
        call _hldiv10   ;=$4044  a=hl%10  hl=hl/10
        add a,$30       ;convert to decimal digit
        ld (de),a       ;store it
        dec de
        djnz atodecmain
        ld hl, num_spot
		xor a
		add a, 48		;char code for zero
		cp (hl)
		jr nz, atodecdisp
		inc hl
		cp (hl)
		jr nz, atodecdisp
		inc hl
atodecdisp:
        call _vputs     ;display it
        ret
num_spot:
	.db $00,$00,$00,0
;-----------------------------------





sqrtkeycode_end:
.end
